package com.example.andersb.intentsforbuiltinapps;

import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.provider.ContactsContract;
import android.provider.MediaStore;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;


public class ChoiceActivity extends Activity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_choice);
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.choice, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();
        if (id == R.id.action_settings) {
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    public void browseButtonClicked(View view) {
        Intent intent = new Intent(Intent.ACTION_VIEW, Uri.parse("http://laerer.rhs.dk/andersb/"));
        startActivity(intent);
    }

    public void phoneButtonClicked(View view) {
        Intent intent = new Intent(Intent.ACTION_DIAL, Uri.parse("tel:+45123456"));
        startActivity(intent);
    }


    public void mapButtonClicked(View view) {
        try {
            Intent intent = new Intent(Intent.ACTION_VIEW, Uri.parse("geo:55.64152,12.08035"));
            startActivity(intent);
        } catch (Exception ex) {
            Toast.makeText(getBaseContext(), "Cannot show map", Toast.LENGTH_LONG).show();
        }
    }

    public void cameraButtonClicked(View view) {
        Intent intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
        startActivity(intent);
    }

    private static final int PICK_CONTACT_SUBACTIVITY = 2;

    public void contactsButtonClicked(View view) {
        Intent intent = new Intent(Intent.ACTION_PICK);
        intent.setType(ContactsContract.Contacts.CONTENT_TYPE);
        startActivityForResult(intent, PICK_CONTACT_SUBACTIVITY);
    }

    // Meier: Prof Android 4, page 170
    // http://stackoverflow.com/questions/9496350/pick-a-number-and-name-from-contacts-list-in-android-app
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        TextView resultView = (TextView) findViewById(R.id.resultView);
        if (resultCode == RESULT_CANCELED) {
            resultView.setText("Cancelled. No data.");
            return;
        }
        if (requestCode == PICK_CONTACT_SUBACTIVITY) {
            /// resultView.setText("You picked a contact: " + data.getData().toString());
            Uri contactData = data.getData();
            // Cursor cursor =  managedQuery(contactData, null, null, null, null); // deprecated
            // http://stackoverflow.com/questions/12714701/deprecated-managedquery-issue
            Cursor cursor = getContentResolver().query(contactData, null, null, null, null);
            if (cursor.moveToFirst()) {
                final int columnNameIndex = cursor.getColumnIndexOrThrow(ContactsContract.Contacts.DISPLAY_NAME);
                String name = cursor.getString(columnNameIndex);
                resultView.setText(name);
            }
        }
    }
}
